Index: TvEngine3/TVLibrary/SetupTv/Sections/Helpers/ChannelListHelper.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/Helpers/ChannelListHelper.cs	(revision 0)
+++ TvEngine3/TVLibrary/SetupTv/Sections/Helpers/ChannelListHelper.cs	(revision 0)
@@ -0,0 +1,483 @@
+#region Copyright (C) 2005-2011 Team MediaPortal
+
+// Copyright (C) 2005-2011 Team MediaPortal
+// http://www.team-mediaportal.com
+//
+// MediaPortal is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 2 of the License, or
+// (at your option) any later version.
+//
+// MediaPortal is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with MediaPortal. If not, see <http://www.gnu.org/licenses/>.
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using TvDatabase;
+using TvLibrary.Interfaces;
+using TvLibrary.Log;
+using Gentle.Framework;
+
+namespace SetupTv.Sections.Helpers
+{
+  /// <summary>
+  /// Class that helps to fill any kind of channel list
+  /// </summary>
+  public static class ChannelListHelper
+  {
+    #region dictionaries
+
+    public static IDictionary<int, IList<TuningDetail>> GetDictionaryOfTuningDetailsForGroup(int GroupId, ChannelType chType)
+    {
+      // Create a dictionary of tuning details keyed on channel id.
+      System.Data.IDbCommand icmd = Broker.Provider.GetCommand();
+      string sql = "SELECT * FROM tuningdetail";
+      if ((chType == ChannelType.Tv) || (chType == ChannelType.Radio))
+      {
+        string IsTvOrRadio = (chType == ChannelType.Tv) ? "isTv" : "isRadio";
+        sql += " WHERE (" + IsTvOrRadio + " = true)";
+        if ((GroupId >= 0))
+        {
+          string GroupMapTableName = (chType == ChannelType.Tv) ? "groupmap" : "radiogroupmap";
+          sql += " AND (idchannel IN " +
+                 "(SELECT idChannel FROM " + GroupMapTableName + " WHERE idGroup = " + GroupId + " ORDER BY idChannel))";
+        }
+      }
+      sql += " ORDER BY idChannel";
+      SqlStatement stmt = new SqlStatement(StatementType.Select, icmd, sql);
+      IList<TuningDetail> details = ObjectFactory.GetCollection<TuningDetail>(stmt.Execute());
+      int prevChannelId = -1;
+      IList<TuningDetail> l = new List<TuningDetail>();
+      IDictionary<int, IList<TuningDetail>> d = new Dictionary<int, IList<TuningDetail>>();
+      foreach (TuningDetail detail in details)
+      {
+        if (prevChannelId != detail.IdChannel)
+        {
+          if (l.Count > 0)
+            d.Add(prevChannelId, l);
+          prevChannelId = detail.IdChannel;
+          l = new List<TuningDetail>();
+        }
+        l.Add(detail);
+      }
+      if (prevChannelId != -1)
+      {
+        d.Add(prevChannelId, l);
+      }
+      return d;
+    }
+
+    public static IDictionary<int, Channel> GetDictionaryOfChannelsForGroup(int GroupId, ChannelType chType)
+    {
+      // Create a dictionary of channels keyed on channel id.
+      IList<Channel> channels = GetChannelsOfTypeForGroup(GroupId, chType);
+      IDictionary<int, Channel> d = new Dictionary<int, Channel>();
+      if (channels != null)
+      {
+        foreach (Channel _ch in channels)
+        {
+          d.Add(_ch.IdChannel, _ch);
+        }
+      }
+      return d;
+    }
+
+    public static IDictionary<int, IList<ChannelMap>> GetDictionaryOfChannelMaps(ChannelType chType)
+    {
+      System.Data.IDbCommand icmd = Broker.Provider.GetCommand();
+      string sql = "SELECT * FROM channelmap";
+      if ((chType == ChannelType.Tv) || (chType == ChannelType.Radio))
+      {
+        string IsTvOrRadio = (chType == ChannelType.Tv) ? "isTv = true" : "isRadio = true";
+        sql += " WHERE (idchannel IN " +
+               "(SELECT idChannel FROM channel WHERE (" + IsTvOrRadio + ") ORDER BY idChannel))";
+      }
+      sql += " ORDER BY idChannel";
+      SqlStatement stmt = new SqlStatement(StatementType.Select, icmd, sql);
+      IList<ChannelMap> maps = ObjectFactory.GetCollection<ChannelMap>(stmt.Execute());
+      int prevChannelId = -1;
+      IList<ChannelMap> l = new List<ChannelMap>();
+      IDictionary<int, IList<ChannelMap>> d = new Dictionary<int, IList<ChannelMap>>();
+      foreach (ChannelMap map in maps)
+      {
+        if (prevChannelId != map.IdChannel)
+        {
+          if (l.Count > 0)
+            d.Add(prevChannelId, l);
+          prevChannelId = map.IdChannel;
+          l = new List<ChannelMap>();
+        }
+        l.Add(map);
+      }
+      if (prevChannelId != -1)
+      {
+        d.Add(prevChannelId, l);
+      }
+      return d;
+    }
+
+    public static IDictionary<int, IList<string>> GetDictionaryOfGroupNamesForChannelType(ChannelType chType)
+    {
+      IDictionary<int, string> dGroupNames = new Dictionary<int, string>();
+      if (chType == ChannelType.Tv)
+      {
+        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (ChannelGroup));
+        sb.AddOrderByField("SortOrder");
+        SqlStatement stmnt = sb.GetStatement();
+        IList<ChannelGroup> chGroups = ObjectFactory.GetCollection<ChannelGroup>(stmnt.Execute());
+        foreach (ChannelGroup group in chGroups)
+        {
+          dGroupNames.Add(group.IdGroup, group.GroupName);
+        }
+      }
+      else
+      {
+        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (RadioChannelGroup));
+        sb.AddOrderByField("SortOrder");
+        SqlStatement stmnt = sb.GetStatement();
+        IList<RadioChannelGroup> chGroups = ObjectFactory.GetCollection<RadioChannelGroup>(stmnt.Execute());
+        foreach (RadioChannelGroup group in chGroups)
+        {
+          dGroupNames.Add(group.IdGroup, group.GroupName);
+        }
+      }
+
+
+      // Create a dictionary of group names keyed on channel id.
+      System.Data.IDbCommand icmd = Broker.Provider.GetCommand();
+      string GroupMapTableName = (chType == ChannelType.Tv) ? "groupmap" : "radiogroupmap";
+      string sqlGroupMap = "SELECT * FROM " + GroupMapTableName;
+      if ((chType == ChannelType.Tv) || (chType == ChannelType.Radio))
+      {
+        string IsTvOrRadio = (chType == ChannelType.Tv) ? "isTV" : "isRadio";
+        sqlGroupMap += " WHERE idChannel IN " +
+                       "(SELECT idChannel FROM channel WHERE " + IsTvOrRadio + " = true ORDER BY idChannel)";
+      }
+      sqlGroupMap += " ORDER BY idChannel";
+      SqlStatement stmt = new SqlStatement(StatementType.Select, icmd, sqlGroupMap);
+
+      IList<GroupMap> GroupMaps = ObjectFactory.GetCollection<GroupMap>(stmt.Execute());
+      int prevChannelId = -1;
+      IList<string> l = new List<string>();
+      IDictionary<int, IList<string>> d = new Dictionary<int, IList<string>>();
+      foreach (GroupMap map in GroupMaps)
+      {
+        if (prevChannelId != map.IdChannel)
+        {
+          if (l.Count > 0)
+            d.Add(prevChannelId, l);
+          prevChannelId = map.IdChannel;
+          l = new List<string>();
+        }
+        string GroupName;
+        if (dGroupNames.TryGetValue(map.IdGroup, out GroupName))
+        {
+          l.Add(GroupName);
+        }
+        else
+        {
+          Log.Error("channelgroup for channel id={0} with channelgroup id={1} does not exist", prevChannelId,
+                    map.IdGroup);
+        }
+      }
+      if (prevChannelId != -1)
+      {
+        d.Add(prevChannelId, l);
+      }
+      return d;
+    }
+
+    public static IDictionary<int, CardType> GetDictionaryOfInstalledCardTypes()
+    {
+      IDictionary<int, CardType> cards = new Dictionary<int, CardType>();
+      IList<Card> dbsCards = Card.ListAll();
+      foreach (Card card in dbsCards)
+      {
+        if (card.Enabled == false)
+          continue;
+        if (!TvControl.RemoteControl.Instance.CardPresent(card.IdCard))
+          continue;
+        cards.Add(card.IdCard, TvControl.RemoteControl.Instance.Type(card.IdCard));
+      }
+      return cards;
+    }
+
+  #endregion
+
+    public static IList<Channel> GetChannelsOfTypeForGroup(int GroupId, ChannelType chType)
+    {
+      System.Data.IDbCommand icmd = Broker.Provider.GetCommand();
+      string sql = "SELECT * FROM channel";
+      if ((chType == ChannelType.Tv) || (chType == ChannelType.Radio))
+      {
+        string IsTvOrRadio = (chType == ChannelType.Tv) ? "isTv" : "isRadio";
+        sql += " WHERE (" + IsTvOrRadio + " = true)";
+        if ((GroupId >= 0))
+        {
+          string GroupMapTableName = (chType == ChannelType.Tv) ? "groupmap" : "radiogroupmap";
+          sql += " AND (idchannel IN " +
+                 "(SELECT idChannel FROM " + GroupMapTableName + " WHERE idGroup = " + GroupId + " ORDER BY idChannel))";
+        }
+      }
+      sql += " ORDER BY sortOrder";
+      SqlStatement stmt = new SqlStatement(StatementType.Select, icmd, sql);
+      return ObjectFactory.GetCollection<Channel>(stmt.Execute());
+    }
+
+    public static bool HasWebstreamTuningDetails(IList<TuningDetail> details)
+    {
+      return Channel.HasWebstreamTuningDetails(details);
+    }
+
+    public static bool HasDVBS2Details(TuningDetail detail)
+    {
+      if ( (detail.Modulation != (int)DirectShowLib.BDA.ModulationType.Mod16Qam) &&
+           (detail.RollOff == (int)DirectShowLib.BDA.RollOff.Twenty ||
+            detail.RollOff == (int)DirectShowLib.BDA.RollOff.TwentyFive ||
+            detail.Pilot == (int)DirectShowLib.BDA.Pilot.On ||
+            detail.Modulation == (int)DirectShowLib.BDA.ModulationType.Mod8Psk ||    /* acc.to mm1352000:
+                                                                                * most DVB-S2 channels are 8PSK.
+                                                                                * We store the modulation of DVB-S channels
+                                                                                * as ModNotSet so it should be safe to treat
+                                                                                * Mod8psk as the DVB-S2 8 PSK - DVB-S 8 PSK
+                                                                                * doesn't seem to be very common */
+            detail.Modulation == (int)DirectShowLib.BDA.ModulationType.Mod16Apsk ||
+            detail.Modulation == (int)DirectShowLib.BDA.ModulationType.Mod32Apsk ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate3_5 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate4_5 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate5_11 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate1_4 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate1_3 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate2_5 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate6_7 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate8_9 ||
+            detail.InnerFecRate == (int)DirectShowLib.BDA.BinaryConvolutionCodeRate.Rate9_10
+         ) )
+        return true;
+      else
+        return false;
+    }
+
+    public static string GetMappingNames(IList<ChannelMap> maps, IDictionary<int, CardType> cardtypes, IList<TuningDetail> tuningDetails)
+    {
+      bool HasAnalog = false;
+      bool HasDVBC = false;
+      bool HasDVBT = false;
+      bool HasDVBS = false;
+      bool HasATSC = false;
+      bool HasDVBIP = false;
+      bool HasWebStream = false;
+      bool HasDVBS2 = false;
+      bool HasDVBSOnly = false;
+
+      if (maps != null)
+      {
+        CardType type;
+        foreach (ChannelMap map in maps)
+        {
+          if (cardtypes.TryGetValue(map.IdCard, out type))
+          {
+            switch (type)
+            {
+              case CardType.Analog:
+                HasAnalog = true;
+                break;
+              case CardType.DvbC:
+                HasDVBC = true;
+                break;
+              case CardType.DvbT:
+                HasDVBT = true;
+                break;
+              case CardType.DvbS:
+                HasDVBS = true;
+                break;
+              case CardType.Atsc:
+                HasATSC = true;
+                break;
+              case CardType.DvbIP:
+                HasDVBIP = true;
+                break;
+              case CardType.RadioWebStream:
+                HasWebStream = true;
+                break;
+            }
+          }
+        }
+      }
+
+      if (tuningDetails != null)
+      {
+        foreach (TuningDetail tuningDetail in tuningDetails)
+        {
+          if (HasDVBS)
+          {
+            if (HasDVBS2Details(tuningDetail))
+              HasDVBS2 = true;
+            else
+              HasDVBSOnly = true;
+          }
+        }
+      }
+
+      List<string> mappings = new List<string>();
+      if (HasAnalog)
+        mappings.Add("Analog");
+      if (HasDVBC)
+        mappings.Add("DVB-C");
+      if (HasDVBT)
+        mappings.Add("DVB-T");
+      if (HasDVBSOnly)
+        mappings.Add("DVB-S");
+      if (HasDVBS2)
+        mappings.Add("DVB-S2");
+      if (HasATSC)
+        mappings.Add("ATSC");
+      if (HasDVBIP)
+        mappings.Add("DVB-IP");
+      if (HasWebStream)
+        mappings.Add("Webstream");
+      return String.Join(", ", mappings.ToArray());
+    }
+
+    public static List<TuningDetail> GetTuningDetailsByCardType(Channel channel, IDictionary<int, IList<TuningDetail>> dDetails, CardType cardType, bool enableDVBS2)
+    {
+      List<TuningDetail> result = new List<TuningDetail>();
+      IList<TuningDetail> Details;
+      if (dDetails.TryGetValue(channel.IdChannel, out Details))
+      {
+        foreach (TuningDetail tDetail in Details)
+        {
+          switch (cardType)
+          {
+            case CardType.Analog:
+              if (tDetail.ChannelType == ChannelProviderType.Analog)
+                result.Add(tDetail);
+              break;
+            case CardType.Atsc:
+              if (tDetail.ChannelType == ChannelProviderType.ATSC)
+                result.Add(tDetail);
+              break;
+            case CardType.DvbC:
+              if (tDetail.ChannelType == ChannelProviderType.DVBC)
+                result.Add(tDetail);
+              break;
+            case CardType.DvbS:
+              if (tDetail.ChannelType == ChannelProviderType.DVBS)
+              {
+                if (!enableDVBS2 && ChannelListHelper.HasDVBS2Details(tDetail))
+                {
+                  Log.Debug(String.Format(
+                    "Imported channel {0} detected as DVB-S2. Skipped! \n Enable \"DVB-S2 tuning\" option in your TV-Card properties to be able to map these channels.",
+                    tDetail.Name));
+                }
+                else
+                  result.Add(tDetail);
+              }
+              break;
+            case CardType.DvbT:
+              if (tDetail.ChannelType == ChannelProviderType.DVBT)
+                result.Add(tDetail);
+              break;
+            case CardType.DvbIP:
+              if (tDetail.ChannelType == ChannelProviderType.DVBIP)
+                result.Add(tDetail);
+              break;
+            case CardType.RadioWebStream:
+              if (tDetail.ChannelType == ChannelProviderType.WebStream)
+                result.Add(tDetail);
+              break;
+          }
+        }
+      }
+      return result;
+    }
+  }
+
+  public static class ChannelListIcons
+  {
+    /// <summary>
+    /// Icon for radio channel with FTA flag or without any flag
+    /// </summary>
+    public static int Radio_FTA = 0;
+
+    /// <summary>
+    /// Icon for radio scrambled channel
+    /// </summary>
+    public static int Radio_Scrambled = 1;
+
+    /// <summary>
+    /// Icon for radio FTA and scrambled channel (combined)
+    /// </summary>
+    public static int Radio_FTA_Scrambled = 2;
+
+    /// <summary>
+    /// Icon for TV channel with FTA flag or without any flag
+    /// </summary>
+    public static int TV_FTA = 3;
+
+    /// <summary>
+    /// Icon for TV scrambled channel
+    /// </summary>
+    public static int TV_Scrambled = 4;
+
+    /// <summary>
+    /// Icon for TV FTA and scrambled channel (combined)
+    /// </summary>
+    public static int TV_FTA_Scrambled = 5;
+
+    private static int GetChannelListIconIndex(ChannelType _type, bool IsFTA, bool IsScrambled)
+    {
+      switch (_type)
+      {
+        case ChannelType.Tv:
+          if (IsFTA && IsScrambled)
+            return TV_FTA_Scrambled;
+          else if (IsScrambled)
+            return TV_Scrambled;
+          else
+            return TV_FTA;
+
+        case ChannelType.Radio:
+          if (IsFTA && IsScrambled)
+            return Radio_FTA_Scrambled;
+          else if (IsScrambled)
+            return Radio_Scrambled;
+          else
+            return Radio_FTA;
+
+        default:
+          return -1;
+      }
+    }
+
+    public static int GetChannelListIconIndex(Channel _ch, IList<TuningDetail> TuningDetailsList)
+    {
+      bool hasFta = false;
+      bool hasScrambled = false;
+      if (TuningDetailsList != null)
+      {
+        foreach (TuningDetail detail in TuningDetailsList)
+        {
+          if (detail.FreeToAir)
+          {
+            hasFta = true;
+          }
+          if (!detail.FreeToAir)
+          {
+            hasScrambled = true;
+          }
+        }
+      }
+      ChannelType _type = (_ch.IsTv ? ChannelType.Tv : (_ch.IsRadio ? ChannelType.Radio : ChannelType.All));
+      return GetChannelListIconIndex(_type, hasFta, hasScrambled);
+    }
+  }
+
+}
\ No newline at end of file
Index: TvEngine3/TVLibrary/SetupTv/Sections/Helpers/ChannelListViewHandler.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/Helpers/ChannelListViewHandler.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/Helpers/ChannelListViewHandler.cs	(working copy)
@@ -20,13 +20,11 @@
 
 using System;
 using System.Collections.Generic;
-using System.Text;
 using System.Windows.Forms;
 using TvDatabase;
 using TvLibrary.Interfaces;
 using TvLibrary.Log;
 using System.Threading;
-using SetupControls;
 
 namespace SetupTv.Sections.Helpers
 {
@@ -46,6 +44,11 @@
     private ChannelType _type; //the type of the texbox, currently that's tv or radio
     private Dictionary<int, ListViewItem> _listViewCache; //A list of allready created listviewitems
 
+    private IDictionary<int, IList<TuningDetail>> dTuningDetails;
+    private IDictionary<int, Channel> dChannels;
+    private IDictionary<int, IList<ChannelMap>> dChannelMaps;
+    private IDictionary<int, IList<string>> dChannelGroupNames;
+
     /// <summary>
     /// Creates a new ChannelListView Handler
     /// </summary>
@@ -53,6 +56,7 @@
     /// <param name="channels"></param>
     /// <param name="allCards"></param>
     /// <param name="textBox"></param>
+    /// <param name="type"></param>
     internal ChannelListViewHandler(ListView listView, IList<Channel> channels, Dictionary<int, CardType> allCards,
                                     TextBox textBox, ChannelType type)
     {
@@ -62,6 +66,11 @@
       _currentText = textBox;
       _type = type;
       _listViewCache = new Dictionary<int, ListViewItem>();
+
+      dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(-1, type);
+      dTuningDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, type);
+      dChannelMaps = ChannelListHelper.GetDictionaryOfChannelMaps(type);
+      dChannelGroupNames = ChannelListHelper.GetDictionaryOfGroupNamesForChannelType(type);
     }
 
     /// <summary>
@@ -105,7 +114,7 @@
 
       try
       {
-        Log.Debug("Filter listview for " + filterText);
+        Log.Debug("Filter listview for \"" + filterText + "\"");
         _listView.Invoke(new MethodInvoker(delegate()
                                              {
                                                _listView.Items.Clear();
@@ -118,7 +127,7 @@
           if (InvokeHasTextChanged(filterText))
           {
 //the search term changed while we were filtering
-            Log.Debug("Cancel filtering for " + filterText);
+            Log.Debug("Cancel filtering for \"" + filterText + "\"");
             break;
           }
 
@@ -141,7 +150,7 @@
                                                  _listView.Items.AddRange(items.ToArray());
                                                  _listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize);
                                                }));
-          Log.Debug("Finished filtering " + items.Count + " items for " + filterText);
+          Log.Debug("Finished filtering " + items.Count + " items for \"" + filterText + "\"");
         }
         else
         {
@@ -195,188 +204,72 @@
     /// <returns>Listview item representing the channel</returns>
     internal ListViewItem CreateListViewItemForChannel(Channel ch, Dictionary<int, CardType> cards)
     {
-      if (_listViewCache.ContainsKey(ch.IdChannel)) return _listViewCache[ch.IdChannel];
+      if (_listViewCache.ContainsKey(ch.IdChannel))
+        return _listViewCache[ch.IdChannel];
 
-      bool analog = false;
-      bool dvbc = false;
-      bool dvbt = false;
-      bool dvbs = false;
-      bool atsc = false;
-      bool dvbip = false;
-      bool webstream = false;
-      bool notmapped = true;
-      if (ch.IsWebstream())
+      bool hasTuningDetails;
+      ListViewItem item = new ListViewItem(ch.DisplayName);
+      IList<TuningDetail> tuningDetails;
+      IList<ChannelMap> maps;
+
+      try
       {
-        webstream = true;
-        notmapped = false;
-      }
-      if (notmapped)
-      {
-        IList<ChannelMap> maps = ch.ReferringChannelMap();
-        foreach (ChannelMap map in maps)
+        hasTuningDetails = dTuningDetails.TryGetValue(ch.IdChannel, out tuningDetails);
+
+        #region Group names
+        List<string> GroupNamesListNoAll = new List<string>();
+        IList<string> groupnames;
+        if(dChannelGroupNames.TryGetValue(ch.IdChannel, out groupnames))
         {
-          if (cards.ContainsKey(map.IdCard))
+          //Don't add "All Channels"
+          foreach (string groupName in groupnames)
           {
-            CardType type = cards[map.IdCard];
-            switch (type)
+            if (groupName != TvConstants.TvGroupNames.AllChannels &&
+                groupName != TvConstants.RadioGroupNames.AllChannels)
             {
-              case CardType.Analog:
-                analog = true;
-                notmapped = false;
-                break;
-              case CardType.DvbC:
-                dvbc = true;
-                notmapped = false;
-                break;
-              case CardType.DvbT:
-                dvbt = true;
-                notmapped = false;
-                break;
-              case CardType.DvbS:
-                dvbs = true;
-                notmapped = false;
-                break;
-              case CardType.Atsc:
-                atsc = true;
-                notmapped = false;
-                break;
-              case CardType.DvbIP:
-                dvbip = true;
-                notmapped = false;
-                break;
+              GroupNamesListNoAll.Add(groupName);
             }
           }
         }
-      }
-      ListViewItem item = new ListViewItem(ch.DisplayName);
-      item.Checked = ch.VisibleInGuide;
-      item.Tag = ch;
+        string GroupNamesNoAll = String.Join(", ", GroupNamesListNoAll.ToArray());
+        #endregion
 
-
-      IList<string> groups = ch.GroupNames;
-      List<string> groupNames = new List<string>();
-      foreach (string groupName in groups)
-      {
-        if (groupName != TvConstants.TvGroupNames.AllChannels &&
-            groupName != TvConstants.RadioGroupNames.AllChannels)
+        #region Provider names
+        List<string> providers = new List<string>();
+        if (hasTuningDetails)
         {
-//Don't add "All Channels"
-          groupNames.Add(groupName);
+          foreach (TuningDetail detail in tuningDetails)
+          {
+            if (!providers.Contains(detail.Provider) && !String.IsNullOrEmpty(detail.Provider))
+            {
+              providers.Add(detail.Provider);
+            }
+          }
         }
-      }
-      string group = String.Join(", ", groupNames.ToArray());
-      item.SubItems.Add(group);
+        string ProviderNames = String.Join(", ", providers.ToArray());
+        #endregion
 
-      List<string> providers = new List<string>();
-      IList<TuningDetail> tuningDetails = ch.ReferringTuningDetail();
-      bool hasFta = false;
-      bool hasScrambled = false;
-      foreach (TuningDetail detail in tuningDetails)
-      {
-        if (!providers.Contains(detail.Provider) && !String.IsNullOrEmpty(detail.Provider))
-        {
-          providers.Add(detail.Provider);
-        }
-        if (detail.FreeToAir)
-        {
-          hasFta = true;
-        }
-        if (!detail.FreeToAir)
-        {
-          hasScrambled = true;
-        }
-      }
+        #region Mapping Names
+        dChannelMaps.TryGetValue(ch.IdChannel, out maps);
+        string MappingNames = ChannelListHelper.GetMappingNames(maps, cards, tuningDetails);
+        if (MappingNames.Length == 0)
+          MappingNames = "Channel not mapped to a card";
+        #endregion
 
-      string provider = String.Join(", ", providers.ToArray());
-      item.SubItems.Add(provider);
+        item.Checked = ch.VisibleInGuide;
+        item.ImageIndex = ChannelListIcons.GetChannelListIconIndex(ch, tuningDetails);
+        item.Tag = ch;
+        item.SubItems.Add(GroupNamesNoAll);
+        item.SubItems.Add(ProviderNames);
+        item.SubItems.Add(MappingNames);
+        item.SubItems.Add(hasTuningDetails ? tuningDetails.Count.ToString() : "0");
 
-      int imageIndex = 0;
-      if (_type == ChannelType.Tv)
-      {
-        if (hasFta && hasScrambled)
-        {
-          imageIndex = 5;
-        }
-        else if (hasScrambled)
-        {
-          imageIndex = 4;
-        }
-        else
-        {
-          imageIndex = 3;
-        }
+        _listViewCache.Add(ch.IdChannel, item);
       }
-      else if (_type == ChannelType.Radio)
+      catch (Exception exp)
       {
-        if (hasFta && hasScrambled)
-        {
-          imageIndex = 2;
-        }
-        else if (hasScrambled)
-        {
-          imageIndex = 1;
-        }
-        else
-        {
-          imageIndex = 0;
-        }
+        Log.Error("RefreshAllChannels error: {0}", exp.StackTrace);
       }
-      item.ImageIndex = imageIndex;
-
-      StringBuilder builder = new StringBuilder();
-
-      if (notmapped)
-      {
-        builder.Append("Channel not mapped to a card");
-      }
-      else
-      {
-        if (analog)
-        {
-          builder.Append("Analog");
-        }
-        if (dvbc)
-        {
-          if (builder.Length > 0)
-            builder.Append(",");
-          builder.Append("DVB-C");
-        }
-        if (dvbt)
-        {
-          if (builder.Length > 0)
-            builder.Append(",");
-          builder.Append("DVB-T");
-        }
-        if (dvbs)
-        {
-          if (builder.Length > 0)
-            builder.Append(",");
-          builder.Append("DVB-S");
-        }
-        if (atsc)
-        {
-          if (builder.Length > 0)
-            builder.Append(",");
-          builder.Append("ATSC");
-        }
-        if (dvbip)
-        {
-          if (builder.Length > 0) builder.Append(",");
-          builder.Append("DVB-IP");
-        }
-        if (webstream)
-        {
-          if (builder.Length > 0)
-            builder.Append(",");
-          builder.Append("Webstream");
-        }
-      }
-
-      item.SubItems.Add(builder.ToString());
-      item.SubItems.Add(tuningDetails.Count.ToString());
-
-      _listViewCache.Add(ch.IdChannel, item);
-
       return item;
     }
   }
Index: TvEngine3/TVLibrary/SetupTv/Sections/ImportExport.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/ImportExport.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/ImportExport.cs	(working copy)
@@ -160,7 +160,7 @@
           AddAttribute(nodeTune, "IdTuning", detail.IdTuning);
           AddAttribute(nodeTune, "Bandwidth", detail.Bandwidth);
           AddAttribute(nodeTune, "ChannelNumber", detail.ChannelNumber);
-          AddAttribute(nodeTune, "ChannelType", detail.ChannelType);
+          AddAttribute(nodeTune, "ChannelType", (int)detail.ChannelType);
           AddAttribute(nodeTune, "CountryId", detail.CountryId);
           AddAttribute(nodeTune, "Diseqc", detail.Diseqc);
           AddAttribute(nodeTune, "FreeToAir", detail.FreeToAir);
